﻿<?xml version="1.0" encoding="UTF-8"?>

<!-- Generates a SQL DDL from the XML output of the Orthogonal Toolbox			-->
<!-- Orthogonal Toolbox is a free utility produced by Orthogonal Software Corporation	-->
<!-- http://www.orthogonalsoftware.com												-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" version="1.0" encoding="UTF-8" indent="no"/>
	<xsl:template match="/">
	<html>
	<head>
	<title>xml</title>
	</head>
	<body>
		<xsl:apply-templates/>
	</body>
	</html>
	</xsl:template>
	
	<xsl:template match="LogicalModels">
		<xsl:for-each select="LogicalModel">/* DDL generated from <xsl:value-of select="@FileName"/> last saved on <xsl:value-of select="@FileSavedOn"/> */
<p />
<xsl:apply-templates select="Entities/Entity[@IsView='false']" mode="table"/>
<xsl:apply-templates select="Relationships/Relationship" mode="fk"/>
</xsl:for-each>
</xsl:template>
	
	<xsl:template match="Entity" mode="table">
create table dbo.[<xsl:value-of select="@PhysicalName"/>] 
(
	<br />
	<xsl:for-each select="EntityAttributes/EntityAttribute">
		<span style="padding-left: 20px;">
		<xsl:apply-templates select="../../../../Attributes/Attribute[@AttributeID = current()/@EntityAttributeID]" mode="table"/>
		</span>
		<xsl:if test="count(../../EntityAttributes/EntityAttribute) != position()">,</xsl:if>
		<br />
	</xsl:for-each>
)
<br />
go
<p />

<xsl:apply-templates select="EntityAnnotations/EntityAnnotation[@AnnotationType='Primary Key']" mode="pk"/>
<xsl:apply-templates select="EntityAnnotations/EntityAnnotation[@AnnotationType='Alternate Key']" mode="ak"/>
<xsl:apply-templates select="EntityAnnotations/EntityAnnotation[@AnnotationType='Index']" mode="idx"/>
</xsl:template>

	<!-- Create column for each EntityAttribute -->
	<xsl:template match="Attribute" mode="table">
		<xsl:variable name="nullability">
			<xsl:choose>
				<xsl:when test='@AllowNulls = "false"'> not null</xsl:when>
				<xsl:otherwise> null</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
	[<xsl:value-of select="@PhysicalName"/>] <xsl:value-of select="@PhysicalDatatype"/>  <xsl:value-of select="$nullability"/>
		
</xsl:template>

<xsl:template match="EntityAnnotation" mode="pk">
	
	alter table dbo.[<xsl:value-of select="../../@PhysicalName"/>] 
		<br />
		<span style="padding-left: 20px;">
		add constraint [<xsl:value-of select="@ConstraintName"/>] 
		</span>
		<br />
		<span style="padding-left: 20px;">
		primary key (<xsl:for-each select="EntityAnnotationAttributes/EntityAnnotationAttribute">[<xsl:value-of select="../../../../../../Attributes/Attribute[@AttributeID = current()/@EntityAnnotationAttributeID]/@PhysicalName"/>]<xsl:if test="count(../../EntityAnnotationAttributes/EntityAnnotationAttribute) != position()">, </xsl:if></xsl:for-each>)
		</span>
	<br />
	go
	<p />
</xsl:template>

	<xsl:template match="EntityAnnotation" mode="ak">
create unique index [<xsl:value-of select="@ConstraintName"/>] on dbo.[<xsl:value-of select="../../@PhysicalName"/>] (<xsl:for-each select="EntityAnnotationAttributes/EntityAnnotationAttribute">[<xsl:value-of select="../../../../../../Attributes/Attribute[@AttributeID = current()/@EntityAnnotationAttributeID]/@PhysicalName"/>]<xsl:if test="count(../../EntityAnnotationAttributes/EntityAnnotationAttribute) != position()">, </xsl:if></xsl:for-each>)

go
<p />

</xsl:template>

	<xsl:template match="EntityAnnotation" mode="idx">
create index [<xsl:value-of select="@ConstraintName"/>] on dbo.[<xsl:value-of select="../../@PhysicalName"/>] (<xsl:for-each select="EntityAnnotationAttributes/EntityAnnotationAttribute">[<xsl:value-of select="../../../../../../Attributes/Attribute[@AttributeID = current()/@EntityAnnotationAttributeID]/@PhysicalName"/>]<xsl:if test="count(../../EntityAnnotationAttributes/EntityAnnotationAttribute) != position()">, </xsl:if></xsl:for-each>)

go
<p />

</xsl:template>

	<xsl:template match="Relationship" mode="fk">
	<xsl:variable name="ri">
		<xsl:choose>
			<xsl:when test='@UpdateRule="No Action"'>on update no action </xsl:when>
			<xsl:when test='@UpdateRule="Cascade"'>on update cascade </xsl:when>
			<xsl:when test='@UpdateRule="Set Null"'></xsl:when>
			<xsl:when test='@UpdateRule="Set Default"'></xsl:when>
			<xsl:when test='@UpdateRule="Do Not Enforce"'></xsl:when>
			<xsl:otherwise></xsl:otherwise>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test='@DeleteRule="No Action"'>on delete no action</xsl:when>
			<xsl:when test='@DeleteRule="Cascade"'>on delete cascade</xsl:when>
			<xsl:when test='@DeleteRule="Set Null"'></xsl:when>
			<xsl:when test='@DeleteRule="Set Default"'></xsl:when>
			<xsl:when test='@DeleteRule="Do Not Enforce"'></xsl:when>
			<xsl:otherwise></xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="disable_ri">
		<xsl:choose>
			<xsl:when test='@UpdateRule="Set Null" or @UpdateRule="Set Default" or @UpdateRule="Do Not Enforce" or @DeleteRule="Set Null" or @DeleteRule="Set Default" or @DeleteRule="Do Not Enforce"'>
<br />
go
<p />

		alter table dbo.[<xsl:value-of select="../../Entities/Entity[@EntityID = current()/@FirstEntityID]/@PhysicalName"/>] nocheck constraint [<xsl:value-of select="@PhysicalName"/>]</xsl:when>
			<xsl:otherwise></xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	
	alter table dbo.[<xsl:value-of select="../../Entities/Entity[@EntityID = current()/@FirstEntityID]/@PhysicalName"/>] 
		<br />
		<span style="padding-left: 20px;">
		add constraint [<xsl:value-of select="@PhysicalName"/>] 
		</span>
		<br />
		<span style="padding-left: 20px;">
		foreign key (<xsl:for-each select="FirstAttributes/FirstAttribute">[<xsl:value-of select="../../../../Attributes/Attribute[@AttributeID = current()/@FirstAttributeID]/@PhysicalName"/>]<xsl:if test="count(../../FirstAttributes/FirstAttribute) != position()">, </xsl:if></xsl:for-each>)
		</span>
		<br />
		<span style="padding-left: 20px;">
		references dbo.[<xsl:value-of select="../../Entities/Entity[@EntityID = current()/@SecondEntityID]/@PhysicalName"/>] (<xsl:for-each select="SecondAttributes/SecondAttribute">[<xsl:value-of select="../../../../Attributes/Attribute[@AttributeID = current()/@SecondAttributeID]/@PhysicalName"/>]<xsl:if test="count(../../SecondAttributes/SecondAttribute) != position()">, </xsl:if></xsl:for-each>) 
		</span>
	<xsl:value-of select="$ri"/><xsl:value-of select="$disable_ri"/>
<br />
go
<p />
</xsl:template>
	
</xsl:stylesheet>
<!-- © 2004 Orthogonal Software Corporation. All rights reserved. -->
